<?php
class StringEncrypt
{
	protected $errors = array(
		0 => 'ERROR_SUCCESS',
		1 => 'ERROR_EMPTY_LABEL',
		2 => 'ERROR_LENGTH_LABEL',
		3 => 'ERROR_EMPTY_STRING',
		4 => 'ERROR_EMPTY_BYTES',
		5 => 'ERROR_EMPTY_INPUT',
		6 => 'ERROR_LENGTH_STRING',
		7 => 'ERROR_INVALID_LANG',
		8 => 'ERROR_INVALID_LOCALE',
		9 => 'ERROR_CMD_MIN',
		10 => 'ERROR_CMD_MAX',
		100 => 'ERROR_DEMO'
	);
	protected $api_url = 'https://www.stringencrypt.com/api.php';
	protected $api_version = 'StringEncrypt-PHP/2.0';
	public $code = '';
	public function __construct($code = null)
	{
		if (!empty($code)) {
			$this->code = $code;
		}
	}
	public function encrypt($params = array())
	{
		$params = $this->merge_params($params);
		$query  = http_build_query($params);
		$ch     = curl_init();
		if ($ch) {
			curl_setopt_array($ch, array(
				CURLOPT_URL => $this->api_url,
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_HEADER => false,
				CURLOPT_USERAGENT => $this->api_version,
				CURLOPT_HTTPHEADER => array(
					'Accept: application/json',
				),
				CURLOPT_POST => true,
				CURLOPT_SSL_VERIFYPEER => false,
				CURLOPT_SSL_VERIFYHOST => false,
				CURLOPT_POSTFIELDS => $query
			));
			$results = curl_exec($ch);
			curl_close($ch);
			if ($results) {
				$response = json_decode($results, true);
				if ($response != false) {
					return $response;
				}
			}
		}
		return false;
	}
	public function get_error($error_code)
	{
		return $this->errors[$error_code];
	}
	private function merge_params($params)
	{
		$defaults = array(
			'code' => $this->code,
			'command' => 'encrypt',
			'compression' => false,
			'unicode' => true,
			'lang_locale' => 'en_US.utf8',
			'new_lines' => 'lf',
			'ansi_encoding' => 'WINDOWS-1250',
			'lang' => 'cpp',
			'cmd_min' => 1,
			'cmd_min' => 3,
			'local' => 'false'
		);
		$result   = $defaults;
		foreach ($params as $key => $value) {
			if (!is_null($value)) {
				$result[$key] = $value;
			}
		}
		foreach ($result as $key => $value) {
			if ($value == '') {
				unset($result[$key]);
			}
		}
		return $result;
	}
}
